//
//  Board.m
//  tictactoe
//
//  Created by VENKAT SUBRAMANIAM on 11/30/10.
//  Copyright 2010 Agile Developer, Inc. All rights reserved.
//

#import "Board.h"

@implementation Board

@synthesize nextPegIsX;
@synthesize pegPlaced;
@synthesize firstPlayerSet;

+(id) init {
	if (self = [super init]) {
		[self initialize];
	}
	
	return self;
}

-(void) initialize {
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < 3; j++) {
			self->pegs[i][j] = 0;
		}
	}	
}

-(BOOL) isRowWin {
	for (int i = 0; i < 3; i++) {
		if(self->pegs[i][0] == self->pegs[i][1] &&
		   self->pegs[i][1] == self->pegs[i][2] &&
		   self->pegs[i][0] != 0) return TRUE;
	}
	
	return FALSE;
}

-(BOOL) isColumnWin {
	for (int i = 0; i < 3; i++) {
		if(self->pegs[0][i] == self->pegs[1][i] &&
		   self->pegs[1][i] == self->pegs[2][i] &&
		   self->pegs[0][i] != 0) return TRUE;
	}
	
	return FALSE;
}

-(BOOL) isDiagonalWin {
	if (self->pegs[0][2] == self->pegs[1][1] &&
		self->pegs[0][2] == self->pegs[2][0] &&
		self->pegs[0][2] != 0) return TRUE;

	if (self->pegs[0][0] == self->pegs[1][1] &&
		self->pegs[0][0] == self->pegs[2][2] &&
		self->pegs[0][0] != 0) return TRUE;
	
	return FALSE;	    
}

-(BOOL) isGameOver {
	return self.isRowWin || self.isColumnWin || self.isDiagonalWin;
}

-(void) setFirstPlayerPegIsX: (BOOL) isX {
	if (self.pegPlaced == TRUE) {
		@throw [NSException exceptionWithName: @"Can't set first player" reason: @"A peg has already been placed" userInfo: nil];
	}
	
	self.firstPlayerSet = TRUE;
	self.nextPegIsX = isX;
}

-(BOOL) isFirstPlayerPegX {
	return self.nextPegIsX;
}

-(void) placePegAtRow: (NSInteger) row column: (NSInteger) column {
	if (self.firstPlayerSet == FALSE) {
		@throw [NSException exceptionWithName: @"Can't set peg" reason: @"You've not set the first player peg yet" userInfo: nil];
	}
	self.pegPlaced = TRUE;
	
	if (self->pegs[row][column] != 0) {
		@throw [NSException exceptionWithName: @"Can't set peg" reason: @"Already a peg at location" userInfo: nil];
	}
	
	self->pegs[row][column] = 1;
	if (self.nextPegIsX == FALSE) {
		self->pegs[row][column] = 2;
	}
	
	self.nextPegIsX = !self.nextPegIsX;
}

-(BOOL) isPegXAtRow: (NSInteger) row column: (NSInteger) column {
	if (self->pegs[row][column] == 0) {
		@throw [NSException exceptionWithName: @"Can't return valid result" reason: @"Position is empty" userInfo: nil];
	}
	return self->pegs[row][column] == 1;
}

-(BOOL) isNextPegX {
	return [self nextPegIsX];
}

@end
